CON
  _clkmode = xtal1 + pll16x
'  _xinfreq = 6_000_000
  _clkfreq = 96_000_000

  forcesync = false ' prevents proper connect-on-restart, but allows for more reliable linkage on some ROMs

OBJ
  term   : "FullDuplexSerial"
  adb    : "adb-shell-module"
  outbuf : "stringoutput_external_buffer"
  inbuf  : "stringoutput_external_buffer"

  adc:"AD7706-2wire"


con ' adc specific

selectpin = 20    ' can just be tied high on the adc if desired
clokpin = 22
rxpin =  23
txpin =  23
rdypin = -1 

ADCCLOCK_SLOW = %0000_1101
ADCCLOCK_FAST = %0000_0101

  
PUB demo
  term.start(31,30,0,115200)
  outbuf.init(@outbufmem,128)
  inbuf.init(@inbufmem,128)


adc.select(selectpin)
adc.init(clokpin,rxpin,txpin,rdypin)

adc.ConfigureChannel1(ADCCLOCK_FAST,%01_000_1_0_0) 
adc.ConfigureChannel2(ADCCLOCK_FAST,%01_000_1_0_0) 
adc.ConfigureChannel3(ADCCLOCK_FAST,%01_000_1_0_0)

{
repeat
  term.str(string("Test circuit for the ADC thingie  "))
  term.dec(adc.GetChannel1)
  term.tx(" ")
  term.dec(adc.GetChannel2)
  term.tx(" ")
  term.dec(adc.GetChannel3)
  term.tx(13)
  term.tx(10)

}




 ' bytemove(adb.shellbuf,string("tcp:01234"),10)

 ' start and then stop or even reboot = thing generally dies, needs unplug/replug (the prop must know it has been disconnected)

repeat
    result := \adb.Start
    if(result==0)
       result := \CommandLoop
    term.dec(result)
    if (forcesync==false and -result > 130 and -result < 140)
       reboot
until result>-1




var
byte shellflag

pri CommandLoop | logcycle
         

cmd (string("logcat -c",13,10),1,false)
cmd (string("logcat -v raw PROPBRIDGE_IN:* *:S",13,10),1,false)
cmd (string("echo \$PD,254,9999,2* > /data/local/PROPBRIDGE_OUT",13,10),0,false)
cmd (string("chmod 666 /data/local/PROPBRIDGE_OUT",13,10),0,false)


if (forcesync)
  cmd (string("ls -l",13,10),0,false) ' if sync isn't very good, causes a reset
  repeat 3
   cmd (string(13,10),0,false) 


logcycle:=10
repeat
  logcycle--
  repeat 
   result := adb.rx
   if (result)   ' can this be done better?
     if (adb.id==1 or shellflag)
       if (strsize(adb.rxbuf)>1)
       'term.tx("{")
       'term.dec(adb.id)
       'term.tx("|")
       'term.dec(strsize(adb.rxbuf))
       'term.tx("}")
         term.str(adb.rxbuf)
         
         ' this is where a command interpreter would go
         
         
   adb.rxclr
  until result==0

  chin := term.rxcheck
  if (chin>-1)
    inbuf.tx(chin)
    
    if (chin==13 or inbuf.remaining < 80)
     if (byte[@inbufmem]=="~") ' allow access to shell just in case
      if (byte[@inbufmem+1]=="!") ' ~! is global reboot
       cmd(string("reboot",13,10),0,false)
       adb.closeall
       waitcnt(cnt+_clkfreq)
       reboot
      else
       adb.str(@inbufmem+1,0)
       inbuf.zap(0)
       shellflag~~

     else

      outbuf.str(string("echo ",quote))
      byte[@inbufmem+strsize(@inbufmem)-1]~ ' remove crlf
      if (byte[@inbufmem] == "$")
         outbuf.tx("\")
      outbuf.str(@inbufmem)
      outbuf.str(string(quote," >> /data/local/PROPBRIDGE_OUT",13,10))
      adb.str(@outbufmem,0)
      inbuf.zap(0)
      outbuf.zap(0)
      shellflag~


  elseif (logcycle<0 and shellflag==0)
      logcycle:=50
      outbuf.str(string("echo -n ",quote))
      outbuf.dec(adc.GetChannel2)
      outbuf.tx(" ")
      outbuf.dec(adc.GetChannel1)
      outbuf.tx(" ")
      outbuf.dec(adc.GetChannel3)
      outbuf.str(string(" ",quote," >> /sdcard/PROPBRIDGE_ADC",13,10))
      adb.str(@outbufmem,0)
      outbuf.zap(0)

      cmd(string("date >> /sdcard/PROPBRIDGE_ADC",13,10),0,0)

con
quote = 34
pri cmd(what, who,echo)
adb.str(what,who)
result~~
repeat
  result := adb.rx
   if (echo)
       term.tx("{")
       term.dec(adb.id)
       term.tx("}")
       term.str(adb.rxbuf)
   adb.rxclr
until result==0
var
long chin
byte inbufmem[128]
byte outbufmem[128]